<?php

/**
 * ca_nov_recla_sald_contab actions.
 *
 * @package    cartera
 * @subpackage ca_nov_recla_sald_contab
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class ca_nov_recla_sald_contabActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_NOV_RECLA_SALD_CONTAB_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_NOV_RECLA_SALD_CONTAB_V' =>
        array(
            'id_nov_recla_sald_contab' => 'id_nov_recla_sald_contab',
            'id_anhos' => 'id_anhos',
            'id_meses' => 'id_meses',
            'catalogo' => 'catalogo',
            'auxiliar' => 'auxiliar',
            'fecha_proceso' => 'fecha_proceso',
            'usuariolog' => 'usuariolog',
            'fecha_log' => 'fecha_log',
            'valor' => 'valor',
            'num_doc' => 'num_doc',
            'id_ts_td' => 'id_ts_td',
            'fecha_doc' => 'fecha_doc',
            'id_mae_ter_ant' => 'id_mae_ter_ant',
            'id_mae_ter' => 'id_mae_ter',
            'observaciones' => 'observaciones',
            'catalogo_act' => 'catalogo_act',
            'auxiliar_act' => 'auxiliar_act',
            'num_doc_ant' => 'num_doc_ant',
            'razon_soc_ant' => 'razon_soc_ant',
            'num_doc_nuevo' => 'num_doc_nuevo',
            'razon_soc_nuevo' => 'razon_soc_nuevo',
            'cod_tipo_doc' => 'cod_tipo_doc',
            'tipo_doc' => 'tipo_doc'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_NOV_RECLA_SALD_CONTAB_V' => array(
            'id_nov_recla_sald_contab,a' => array('!=' => array(-1)),
            'id_nov_recla_sald_contab,b' => array('=' => array('id_nov_recla_sald_contab')),
            'fecha_proceso' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_anhos' => array('=' => array('id_anhos')),
            'id_meses' => array('=' => array('id_meses')),
            'catalogo' => array('=' => array('catalogo')),
            'auxiliar' => array('=' => array('auxiliar')),
            'id_mae_ter_ant' => array('=' => array('id_mae_ter_ant')),
            'id_mae_ter' => array('=' => array('id_mae_ter')),
            'catalogo_act' => array('=' => array('catalogo_act')),
            'auxiliar_act' => array('=' => array('auxiliar_act')),
            'id_ts_td' => array('=' => array('id_ts_td')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $query_qualifier = 'DISTINCT'; //eliminar filas repetivas de consulta sql
    protected $fields_orderBy = array(
        'id_nov_recla_sald_contab', 'fecha_log', 'id_anhos', 'id_meses', 'catalogo', 'auxiliar', 'num_doc_ant', 'num_doc_nuevo'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_nov_recla_sald_contab'; //identificador de la tabla
    protected $id_names = array('id_nov_recla_sald_contab'); //llave primaria
    protected $field_names = array('id_anhos', 'id_meses', 'catalogo', 'auxiliar', 'fecha_proceso', 'usuariolog',
        'fecha_log', 'num_doc', 'id_ts_td', 'fecha_doc', 'id_mae_ter_ant', 'id_mae_ter', 'valor', 'observaciones',
        'catalogo_act', 'auxiliar_act'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_NOV_RECLA_SALD_CONTAB'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
//    protected $has_secuencia = false; //si posee secuencia la tabla
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_nov_recla_sald_contab'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateAdd");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $request['usuariolog'] = $request['username'];
        $valor = $request['valor'];
        $valor_saldo = $request['valor_saldo'];

        /*
         *  Generar errores en $errors
         */
        if ($valor > $valor_saldo) {
            $errors['mensaje'] = "El valor (" . $valor . ") no puede ser mayor al saldo de contabilidad(" . $valor_saldo . ").";
            $errors['servicio'] = "sald_contab";
            $logger->info("El valor (" . $valor . ") no puede ser mayor al saldo de contabilidad(" . $valor_saldo . ").");
        } else {
            $logger->info("Valida que el valor de pago(" . $valor . ") sea mayor o igual al total de la factura(" . $valor_saldo . ").");
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
//        $valor_pago_total_pd = $request['valor_pago_total_pd'];

        /*
         *  Generar errores en $errors
         */
//        if ($valor_pago_total_pd < $valor_total) {
//            $errors['mensaje'] = "El valor del pago es inferior a la factura.";
//            $errors['servicio'] = "factura_pos";
//            $logger->info("El valor del pago(" . $valor_pago_total_pd . ") es inferior a la factura(" . $valor_total . ").");
//        } else {
//            $logger->info("Valida que el valor de pago(" . $valor_pago_total_pd . ") sea mayor o igual al total de la factura(" . $valor_total . ").");
//        }

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $fecha_proceso = CN_TABLE::fechaSistema();

            /**
             * Llamado INTERFAZ CONTABLE - 20171103
             */
            $this->logMessage("INICIO INTERFAZ CONTABLE MOVIMIENTO RECLASIF SALDOS CONTAB CARTERA");

            //Se trae de la configuracion la url que se ha establecido para las interfaces contables
            $arrayAtrib = array();

            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                if ('service_url_local' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        if ($key == 'value') {
                            $service_url = $value;
                        }
                    }
                }
                $int++;
            }
            $url = $service_url;
            $url = $url . 'ejecutaInterfacesContables/list.json?id_mod=11&username=websafi&nitocc=800189921&id_username=946';
            //variables del debito
            //$fecha_proceso = $fecha_sistema;
            $id_mae_ter = 946;
            $mov_ejecutado = "Reclasif-.-Cartera";
            $url = $url . '&fecha_proceso=' . $fecha_proceso;
            $url = $url . '&id_mae_ter=' . $id_mae_ter;
            $url = $url . '&mov_ejecutado=' . $mov_ejecutado;
            //$url = $url . '&id_movimiento=' . $id_cesion_cartera;
            $url = $url . '&tag_portal_web=1'; //facturas portal web - validar el retorno del json

            $ch = curl_init($url);

            //Parametros de retorno en cURL
            curl_setopt($ch, CURLOPT_HEADER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // Skip SSL Verification
            $rta = curl_exec($ch);
            curl_close($ch);

            $arrayRespuesta = json_decode($rta, true);
            //Verifica el status, si es diferente de 0, ocurrio un error al subir la interfaz y debe reportarlo
            if ($arrayRespuesta['response']['status'] == 1) {
                $mensajeError = "Error :: Al generar la interfaz contable.";
                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[ca_cesion_cartera] " . $mensajeError);
            } else {
                $this->logMessage("[ca_cesion_cartera] Genero interfaz contable.");
            }

            $this->logMessage("FIN INTERFAZ CONTABLE CESION CARTERA");
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {

            $fecha_proceso = CN_TABLE::fechaSistema();

            /**
             * Llamado INTERFAZ CONTABLE - 20180823
             */
            $this->logMessage("INICIO INTERFAZ CONTABLE MOVIMIENTO RECLASIF SALDOS CONTAB CARTERA");

            //Se trae de la configuracion la url que se ha establecido para las interfaces contables
            $arrayAtrib = array();

            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                if ('service_url_local' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        if ($key == 'value') {
                            $service_url = $value;
                        }
                    }
                }
                $int++;
            }
            $url = $service_url;
            $url = $url . 'ejecutaInterfacesContables/list.json?id_mod=11&username=websafi&nitocc=800189921&id_username=946';
            //variables del debito
            //$fecha_proceso = $fecha_sistema;
            $id_mae_ter = 946;
            $mov_ejecutado = "Reclasif-.-Cartera";
            $url = $url . '&fecha_proceso=' . $fecha_proceso;
            $url = $url . '&id_mae_ter=' . $id_mae_ter;
            $url = $url . '&mov_ejecutado=' . $mov_ejecutado;
            //$url = $url . '&id_movimiento=' . $id_cesion_cartera;
            $url = $url . '&tag_portal_web=1'; //facturas portal web - validar el retorno del json

            $ch = curl_init($url);

            //Parametros de retorno en cURL
            curl_setopt($ch, CURLOPT_HEADER, 0);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // Skip SSL Verification
            $rta = curl_exec($ch);
            curl_close($ch);

            $arrayRespuesta = json_decode($rta, true);
            //Verifica el status, si es diferente de 0, ocurrio un error al subir la interfaz y debe reportarlo
            if ($arrayRespuesta['response']['status'] == 1) {
                $mensajeError = "Error :: Al generar la interfaz contable.";
                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[ca_cesion_cartera] " . $mensajeError);
            } else {
                $this->logMessage("[ca_cesion_cartera] Genero interfaz contable.");
            }

            $this->logMessage("FIN INTERFAZ CONTABLE CESION CARTERA");
        }

        return $request;
    }

}
